apiVersion: apps/v1
kind: Deployment
metadata:
  name: webuiservice
spec:
  selector:
    matchLabels:
      app: webuiservice
  template:
    metadata:
      labels:
        app: webuiservice
    spec:
      terminationGracePeriodSeconds: 5
      securityContext:
        fsGroup: 472
        supplementalGroups:
          - 0
      containers:
      - name: server
        image: registry.gitlab.com/teraflow-h2020/controller/webui:latest
        imagePullPolicy: Always
        ports:
        - containerPort: 8004 # TODO: define the real port
        env:
        - name: LOG_LEVEL
          value: "DEBUG"
        readinessProbe:
          httpGet:
            path: /healthz/ready
            port: 8004
          initialDelaySeconds: 5
          timeoutSeconds: 1
        livenessProbe:
          httpGet:
            path: /healthz/live
            port: 8004
          initialDelaySeconds: 5
          timeoutSeconds: 1
        resources:
          requests:
            cpu: 250m
            memory: 512Mi
          limits:
            cpu: 700m
            memory: 1024Mi
      - name: grafana
        image: grafana/grafana:8.2.6
        imagePullPolicy: IfNotPresent
        ports:
          - containerPort: 3000
            name: http-grafana
            protocol: TCP
        env:
        - name: GF_SECURITY_ADMIN_PASSWORD
          value: admin123+
        readinessProbe:
          failureThreshold: 3
          httpGet:
            path: /robots.txt
            port: 3000
            scheme: HTTP
          initialDelaySeconds: 5
          periodSeconds: 5
          successThreshold: 1
          timeoutSeconds: 2
        livenessProbe:
          failureThreshold: 3
          initialDelaySeconds: 5
          periodSeconds: 5
          successThreshold: 1
          tcpSocket:
            port: 3000
          timeoutSeconds: 1
        resources:
          requests:
            cpu: 250m
            memory: 750Mi
          limits:
            cpu: 700m
            memory: 1024Mi
---
apiVersion: v1
kind: Service
metadata:
  name: webuiservice
spec:
  type: ClusterIP
  selector:
    app: webuiservice
  ports:
  - name: http
    port: 8004
    targetPort: 8004
---
apiVersion: v1
kind: Service
metadata:
  name: webuiservice-public
  labels:
    app: webuiservice
spec:
  type: NodePort
  selector:
    app: webuiservice
  ports:
  - name: http
    protocol: TCP
    port: 8004
    targetPort: 8004
    nodePort: 30800
  - name: grafana
    protocol: TCP
    port: 3000
    targetPort: 3000
    nodePort: 30300
---
